<?php
/**
 * @package	HikaShop for Joomla!
 * @version	3.0.0
 * @author	hikashop.com
 * @copyright	(C) 2010-2017 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
include_once HIKASHOP_HELPER . 'checkout.php';

class hikashopCheckoutCartHelper extends hikashopCheckoutHelperInterface {
	public function check(&$controller, &$params) {
		return true;
	}

	public function validate(&$controller, &$params, $data = array()) {
		if(empty($data))
			$data = JRequest::getVar('checkout', array(), '', 'array');
		if(empty($data['cart']))
			return true;
		if(empty($data['cart']['item']))
			return false;

		$items = array();
		foreach($data['cart']['item'] as $k => $v) {
			$items[] = array(
				'id' => (int)$k,
				'qty' => (int)$v
			);
		}

		$checkoutHelper = hikashopCheckoutHelper::get();
		$cart = $checkoutHelper->getCart();

		$cartClass = hikashop_get('class.cart');
		if($cartClass->updateProduct($cart->cart_id, $items)) {
			$checkoutHelper->getCart(true);

			$eventParams = null;
			if(!empty($params['src']))
				$eventParams = array('src' => $params['src']);
			$checkoutHelper->addEvent('checkout.cart.updated', $eventParams);

			return true;
		}
		return true;
	}

	public function display(&$view, &$params) {
		$params['show_cart_image'] = $view->config->get('show_cart_image');
		$params['show_product_code'] = $view->config->get('show_code');

		$params['show_delete'] = true;

		$defaultParams = $view->config->get('default_params');
		$params['link_to_product_page'] = !empty($defaultParams['link_to_product_page']);

		if(!empty($params['readonly']))
			$params['status'] = true;

		$view->loadFields();
	}

}
